Whenever an item is consumed from the quickslot it will prioritize stacks within your equipped bag rather than your smallest stack or anything else.
This is compatible with WaterskinReslotting and should be compatible with any mods that add in new items/skills.

It is still in development but parts of it are working so I figured I'd isolate the fully functional parts and release them while I continue to work on the rest. 
The parts it doesn't work for behave *almost exactly as they do in Vanilla.
*If you have an item in a quickslot but don't have the "preferred" stack of it, when you use the quickslot it will prioritize the stack in your bag, rather than the smallest stack. After that they will prioritize the "preferred" stack, as it does in Vanilla.
(When a quickslot consumes an item from a stack, that stack is set as the preferred stack, and it will always try to consume from it until the stack is empty or otherwise unavailable, then it will find another stack and set that as the new preferred stack. For certain items in the DOES NOT CURRENTLY WORK FOR section, this mod does apply, but only when there is no preferred stack. These items are marked with a '*')

CURRENTLY WORKS FOR
bullets (and all firearm skills)
the various stones for sigils
(If it's a skill that consumes an item, this should work for it, even if they're modded in or not listed)
Food items (not including drinks)

DOES NOT CURRENTLY WORK FOR
Waterskins (and any other WaterContainer type items)
*Single use drinkables (potions)
*thrown items (bombs)
*deployed items (traps)

KNOWN BUGS:
If you manually assign a stack of food in your pocket to a quickslot, activating the quickslot will consume 1 food from the stack in your pocket before correcting to a stack in your bag.